-- 5.1/itgm/outfox compat only!
if not PlayerOptions.ConfusionOffset then 
	-- SCREENMAN:SystemMessage('This file has mods that are not compatible with your version of StepMania! Please play on ITGMania/5.1/OutFox.')
	return {} 
end


checked = false
FRAME_RATE = 60
local path = GAMESTATE:GetCurrentSong():GetSongDir()..'lua/'
loadfile(path.."mods.lua")()
loadfile(path.."easing.lua")()

-- i am not taronuke
function mod_do(str,pn)
	if pn then
		if GAMESTATE:IsPlayerEnabled(pn-1) then
			taronuke_mods(str,pn)
		end
	else
		for pn=1,2 do
			if GAMESTATE:IsPlayerEnabled(pn-1) then
				taronuke_mods(str,pn)
			end
		end
	end
end

mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes

---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

function blacksphere(beat)
	for i = 0, 1 do
		local mult = i%2*2-1
		local x = (math.cos(beat * math.pi) * 50 - 50) * mult
		local y = math.sin(beat * math.pi) * 50 * mult
		mod_do('*10000 '..x..' movex'..i..', *10000 '..x..' movex'..(i+2)..', *10000 '..y..' movey'..i..', *10000 '..y..' movey'..(i+2))
	end
end

mod_perframes = {
	{36, 38.5, function(beat)
		blacksphere(ease.outSine(beat - 36, 0, 2, 2.5))
	end},
	{167, 174, function(beat)
		blacksphere(beat < 172 and ease.inOutQuad(beat - 167, 0, -3, 5) or ease.inOutQuad(beat - 172, 1, -1, 2))
	end},
}

local ac = Def.ActorFrame{
	Name= "xtl_actor_d",
	Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat() s:sleep(9e9) end },
	Def.Actor{
		OnCommand=function(s)
			s:queuecommand('Update')
		end,
		UpdateCommand=function(self)
			if GAMESTATE:GetSongBeat()>=0 and not checked then
				checked = true
			end
			local beat = GAMESTATE:GetSongBeat()
			disable = false
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				if table.getn(mod_perframes)>0 then
					for i=1,table.getn(mod_perframes) do
						local a = mod_perframes[i]
						if beat > a[1] and beat < a[2] then
							a[3](beat)
						end
					end
				end
			end
			self:sleep(1/FRAME_RATE)
			self:queuecommand('Update')
		end,
	}
}

return ac